std::basic_string::max_size(3)

NAME
std::basic_string::max_size - std::basic_string::max_size

Synopsis
   size_type max_size() const; (until C++11)
   size_type max_size() const noexcept; (since C++11)
                        (until C++20)
   constexpr size_type max_size() const noexcept; (since C++20)
   Returns the maximum number of elements the string is able to hold due to system or
   library implementation limitations, i.e. std::distance(begin(), end()) for the
   largest string.

Parameters
   (none)

Return value
   Maximum number of characters.

Complexity
   Constant.

Example
// Run this code
 #include <iostream>
 #include <string>
 #include <climits>
 int main()
 {
     std::string s;
     std::cout
         << "Maximum size of a string is " << s.max_size() << " ("
         << std::hex << std::showbase << s.max_size()
         << "), pointer size: " << std::dec
         << CHAR_BIT*sizeof(void*) << " bits\n";
 }

Possible output:
 Maximum size of a string is 9223372036854775807 (0x7fffffffffffffff), pointer size: 64 bits

See also
   size returns the number of characters
   length (public member function)
   max_size returns the maximum number of characters
   (C++17) (public member function of std::basic_string_view<CharT,Traits>)